/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Context;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import gobject.ObjectG;


/** */
public class Context : ObjectG
{
	/** the main Gtk struct */
	protected AsContext* asContext;

	/** Get the main Gtk struct */
	public AsContext* getContextStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asContext;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asContext;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsContext* asContext, bool ownedRef = false)
	{
		this.asContext = asContext;
		super(cast(GObject*)asContext, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_context_get_type();
	}

	/**
	 * Creates a new #AsContext.
	 *
	 * Returns: an #AsContext
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_context_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsContext*) __p, true);
	}

	/**
	 * Returns: The name of the file the data originates from.
	 */
	public string getFilename()
	{
		return Str.toString(as_context_get_filename(asContext));
	}

	/**
	 * Returns: The AppStream format version.
	 */
	public AsFormatVersion getFormatVersion()
	{
		return as_context_get_format_version(asContext);
	}

	/**
	 * Returns: The active locale.
	 */
	public string getLocale()
	{
		return Str.toString(as_context_get_locale(asContext));
	}

	/**
	 * Returns: %TRUE if all locale should be parsed.
	 */
	public bool getLocaleAllEnabled()
	{
		return as_context_get_locale_all_enabled(asContext) != 0;
	}

	/**
	 * Returns: The media base URL.
	 */
	public string getMediaBaseurl()
	{
		return Str.toString(as_context_get_media_baseurl(asContext));
	}

	/**
	 * Returns: The data origin.
	 */
	public string getOrigin()
	{
		return Str.toString(as_context_get_origin(asContext));
	}

	/**
	 * Returns: The data priority.
	 */
	public int getPriority()
	{
		return as_context_get_priority(asContext);
	}

	/**
	 * Returns: The document style.
	 */
	public AsFormatStyle getStyle()
	{
		return as_context_get_style(asContext);
	}

	/**
	 * Returns: %TRUE if a media base URL is set.
	 */
	public bool hasMediaBaseurl()
	{
		return as_context_has_media_baseurl(asContext) != 0;
	}

	/**
	 * Sets the file name we are loading data from.
	 *
	 * Params:
	 *     fname = the new file name.
	 */
	public void setFilename(string fname)
	{
		as_context_set_filename(asContext, Str.toStringz(fname));
	}

	/**
	 * Sets the AppStream format version.
	 *
	 * Params:
	 *     ver = the new format version.
	 */
	public void setFormatVersion(AsFormatVersion ver)
	{
		as_context_set_format_version(asContext, ver);
	}

	/**
	 * Sets the active locale.
	 *
	 * Params:
	 *     value = the new value.
	 */
	public void setLocale(string value)
	{
		as_context_set_locale(asContext, Str.toStringz(value));
	}

	/**
	 * Sets the media base URL.
	 *
	 * Params:
	 *     value = the new value.
	 */
	public void setMediaBaseurl(string value)
	{
		as_context_set_media_baseurl(asContext, Str.toStringz(value));
	}

	/**
	 * Sets the data origin.
	 *
	 * Params:
	 *     value = the new value.
	 */
	public void setOrigin(string value)
	{
		as_context_set_origin(asContext, Str.toStringz(value));
	}

	/**
	 * Sets the data priority.
	 *
	 * Params:
	 *     priority = the new priority.
	 */
	public void setPriority(int priority)
	{
		as_context_set_priority(asContext, priority);
	}

	/**
	 * Sets the AppStream document style.
	 *
	 * Params:
	 *     style = the new document style.
	 */
	public void setStyle(AsFormatStyle style)
	{
		as_context_set_style(asContext, style);
	}
}
