/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module appstream.Issue;

private import appstream.c.functions;
public  import appstream.c.types;
private import glib.ConstructionException;
private import glib.Str;
private import gobject.ObjectG;


/** */
public class Issue : ObjectG
{
	/** the main Gtk struct */
	protected AsIssue* asIssue;

	/** Get the main Gtk struct */
	public AsIssue* getIssueStruct(bool transferOwnership = false)
	{
		if (transferOwnership)
			ownedRef = false;
		return asIssue;
	}

	/** the main Gtk struct as a void* */
	protected override void* getStruct()
	{
		return cast(void*)asIssue;
	}

	/**
	 * Sets our main struct and passes it to the parent class.
	 */
	public this (AsIssue* asIssue, bool ownedRef = false)
	{
		this.asIssue = asIssue;
		super(cast(GObject*)asIssue, ownedRef);
	}


	/** */
	public static GType getType()
	{
		return as_issue_get_type();
	}

	/**
	 * Creates a new #AsIssue.
	 *
	 * Returns: an #AsIssue
	 *
	 * Throws: ConstructionException GTK+ fails to create the object.
	 */
	public this()
	{
		auto __p = as_issue_new();

		if(__p is null)
		{
			throw new ConstructionException("null returned by new");
		}

		this(cast(AsIssue*) __p, true);
	}

	/**
	 * Gets the issue ID (usually a bug number or CVE ID)
	 *
	 * Returns: the ID.
	 */
	public string getId()
	{
		return Str.toString(as_issue_get_id(asIssue));
	}

	/**
	 * Gets the issue type.
	 *
	 * Returns: the #AsIssueKind
	 */
	public AsIssueKind getKind()
	{
		return as_issue_get_kind(asIssue);
	}

	/**
	 * Gets the URL associacted with this issue, usually
	 * referencing a bug report or issue description.
	 *
	 * Returns: the URL.
	 */
	public string getUrl()
	{
		return Str.toString(as_issue_get_url(asIssue));
	}

	/**
	 * Sets the issue ID.
	 *
	 * Params:
	 *     id = the new ID.
	 */
	public void setId(string id)
	{
		as_issue_set_id(asIssue, Str.toStringz(id));
	}

	/**
	 * Sets the issue type.
	 *
	 * Params:
	 *     kind = the #AsIssueKind, e.g. %AS_ISSUE_KIND_SHA256.
	 */
	public void setKind(AsIssueKind kind)
	{
		as_issue_set_kind(asIssue, kind);
	}

	/**
	 * Sets an URL describing this issue.
	 *
	 * Params:
	 *     url = the new URL.
	 */
	public void setUrl(string url)
	{
		as_issue_set_url(asIssue, Str.toStringz(url));
	}
}
