/*
 * Licensed under the GNU Lesser General Public License Version 3
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the license, or
 * (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 */

// generated automatically - do not change


module ascompose.TranslationUtils;

private import ascompose.Result;
private import ascompose.Unit;
private import ascompose.c.functions;
public  import ascompose.c.types;
private import glib.Str;


/** */
public struct TranslationUtils
{

	/**
	 * Searches a prefix for languages, and adds <language/>
	 * tags to the specified component, if it has one or more <translation/> tags
	 * defined to point to the right translation domains and types.
	 *
	 * @min_percentage sets the minimum percentage to add a language tag.
	 * The usual value would be 25% and any language less complete than
	 * this will not be added.
	 *
	 * The purpose of this functionality is to avoid blowing up the size
	 * of the AppStream metadata with a lot of extra data detailing
	 * languages with very few translated strings.
	 *
	 * Params:
	 *     cres = an #AscResult
	 *     unit = an #AscUnit that the result belongs to
	 *     prefix = a prefix to search, e.g. "/usr"
	 *     minPercentage = minimum percentage to add language
	 */
	public static void readTranslationStatus(Result cres, Unit unit, string prefix, uint minPercentage)
	{
		asc_read_translation_status((cres is null) ? null : cres.getResultStruct(), (unit is null) ? null : unit.getUnitStruct(), Str.toStringz(prefix), minPercentage);
	}
}
